#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "usart.h"

uint8_t usartBuffer[256];
volatile uint8_t usartDataSize = 0;
volatile uint8_t bufferIndex = 0;

void usartSendBytesAsync(uint8_t data[], uint8_t size);

int main(void) {
	usartInit();
	sei();
	usartSendBytesAsync((uint8_t*)"test1\r\n", 7);
	usartSendBytesAsync((uint8_t*)"test2\r\n", 7);
	while (1) { }
}

void usartSendBytesAsync(uint8_t data[], uint8_t size) {
	while (usartDataSize);
	for (uint8_t i = 0; i < size; i++) usartBuffer[i] = data[i];
	usartDataSize = size;
	bufferIndex = 0;
	UCSRB |= _BV(UDRIE);
}

ISR(USART_UDRE_vect) {
	if (bufferIndex < usartDataSize) {
		UDR = usartBuffer[bufferIndex++];
	} else {
		UCSRB &= ~_BV(UDRIE);
		usartDataSize = 0;
	}
}